//------------------------------
// matedView.cpp : implementation of the CMatedView class
//
#include "stdafx.h"
#include "mated.h"

#include "matedDoc.h"
#include "matedView.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatedView

IMPLEMENT_DYNCREATE(CMatedView, CFormView)

BEGIN_MESSAGE_MAP(CMatedView, CFormView)
	//{{AFX_MSG_MAP(CMatedView)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_ED_A_RED, OnChangeEdARed)
	ON_EN_CHANGE(IDC_ED_A_GREEN, OnChangeEdAGreen)
	ON_EN_CHANGE(IDC_ED_A_BLUE, OnChangeEdABlue)
	ON_EN_CHANGE(IDC_ED_D_RED, OnChangeEdDRed)
	ON_EN_CHANGE(IDC_ED_D_GREEN, OnChangeEdDGreen)
	ON_EN_CHANGE(IDC_ED_D_BLUE, OnChangeEdDBlue)
	ON_EN_CHANGE(IDC_ED_S_RED, OnChangeEdSRed)
	ON_EN_CHANGE(IDC_ED_S_GREEN, OnChangeEdSGreen)
	ON_EN_CHANGE(IDC_ED_S_BLUE, OnChangeEdSBlue)
	ON_EN_CHANGE(IDC_ED_SHINE, OnChangeEdShine)
	ON_COMMAND(ID_MENU_SEL_STD, OnMenuSelStd)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatedView construction/destruction

CMatedView::CMatedView()
	: CFormView(CMatedView::IDD)
{
	//{{AFX_DATA_INIT(CMatedView)
	m_a_blue = 0.0f;
	m_a_green = 0.0f;
	m_a_red = 0.0f;
	m_d_blue = 0.0f;
	m_d_green = 0.0f;
	m_d_red = 0.0f;
	m_s_blue = 0.0f;
	m_s_green = 0.0f;
	m_s_red = 0.0f;
	m_shine = 0.0f;
	m_scr_a_blue = 0;
	m_scr_a_green = 0;
	m_scr_a_red = 0;
	m_scr_d_blue = 0;
	m_scr_d_green = 0;
	m_scr_d_red = 0;
	m_scr_s_blue = 0;
	m_scr_s_green = 0;
	m_scr_s_red = 0;
	m_scr_shine = 0;
	//}}AFX_DATA_INIT
	str_amb=_T("amb");
	str_dif=_T("diff");
	str_spec=_T("spec");
	str_shine=_T("shine");
}

CMatedView::~CMatedView()
{
	m_pW->DestroyWindow();
	delete m_pW;
	if((m_oldRC!=NULL)&&(m_oldDC!=NULL))
		wglMakeCurrent(m_oldDC,m_oldRC);

}

void CMatedView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatedView)
	DDX_Text(pDX, IDC_ED_A_BLUE, m_a_blue);
	DDV_MinMaxFloat(pDX, m_a_blue, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_A_GREEN, m_a_green);
	DDV_MinMaxFloat(pDX, m_a_green, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_A_RED, m_a_red);
	DDV_MinMaxFloat(pDX, m_a_red, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_D_BLUE, m_d_blue);
	DDV_MinMaxFloat(pDX, m_d_blue, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_D_GREEN, m_d_green);
	DDV_MinMaxFloat(pDX, m_d_green, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_D_RED, m_d_red);
	DDV_MinMaxFloat(pDX, m_d_red, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_S_BLUE, m_s_blue);
	DDV_MinMaxFloat(pDX, m_s_blue, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_S_GREEN, m_s_green);
	DDV_MinMaxFloat(pDX, m_s_green, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_S_RED, m_s_red);
	DDV_MinMaxFloat(pDX, m_s_red, 0.f, 1.f);
	DDX_Text(pDX, IDC_ED_SHINE, m_shine);
	DDV_MinMaxFloat(pDX, m_shine, 0.f, 128.f);
	DDX_Scroll(pDX, IDC_SCROLL_A_BLUE, m_scr_a_blue);
	DDX_Scroll(pDX, IDC_SCROLL_A_GREEN, m_scr_a_green);
	DDX_Scroll(pDX, IDC_SCROLL_A_RED, m_scr_a_red);
	DDX_Scroll(pDX, IDC_SCROLL_D_BLUE, m_scr_d_blue);
	DDX_Scroll(pDX, IDC_SCROLL_D_GREEN, m_scr_d_green);
	DDX_Scroll(pDX, IDC_SCROLL_D_RED, m_scr_d_red);
	DDX_Scroll(pDX, IDC_SCROLL_S_BLUE, m_scr_s_blue);
	DDX_Scroll(pDX, IDC_SCROLL_S_GREEN, m_scr_s_green);
	DDX_Scroll(pDX, IDC_SCROLL_S_RED, m_scr_s_red);
	DDX_Scroll(pDX, IDC_SCROLL_SHINE, m_scr_shine);
	//}}AFX_DATA_MAP
}

BOOL CMatedView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMatedView printing

BOOL CMatedView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMatedView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CMatedView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CMatedView::OnPrint(CDC* pDC, CPrintInfo*)
{
}

/////////////////////////////////////////////////////////////////////////////
// CMatedView diagnostics

#ifdef _DEBUG
void CMatedView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMatedView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMatedDoc* CMatedView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMatedDoc)));
	return (CMatedDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMatedView message handlers

void CMatedView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	// remember the current rendering environment
	m_oldRC=wglGetCurrentContext();
	m_oldDC=wglGetCurrentDC();
	wglMakeCurrent(NULL,NULL);

	// establish the opengl window
	// makes its own rendering context
	// and use it while while it lives
	m_pW=new CMyWin(this);
	
	// Steal the controls rect and
	// set up mywindow, the opengl window, in its place
	CWnd* pW=GetDlgItem(IDC_STATIC_OGLMAIN);
	CRect R;
	pW->GetWindowRect(&R);
	ScreenToClient(&R);

	m_pW->SetWindowPos(&wndTop,R.left,R.top,R.Width(),R.Height(),NULL);
	m_pW->ShowWindow(SW_SHOW);

	// calibrate and initiate scrollbars
	((CScrollBar*)GetDlgItem(IDC_SCROLL_A_RED))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_A_GREEN))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_A_BLUE))->SetScrollRange(0,100);

	((CScrollBar*)GetDlgItem(IDC_SCROLL_D_RED))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_D_GREEN))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_D_BLUE))->SetScrollRange(0,100);

	((CScrollBar*)GetDlgItem(IDC_SCROLL_S_RED))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_S_GREEN))->SetScrollRange(0,100);
	((CScrollBar*)GetDlgItem(IDC_SCROLL_S_BLUE))->SetScrollRange(0,100);
	
	((CScrollBar*)GetDlgItem(IDC_SCROLL_SHINE))->SetScrollRange(0,128);

	// a material to start with
	LoadMaterial(0);
	UpdateData(FALSE);
	UpdateImageAndCode();

}

void CMatedView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(pScrollBar!=NULL) // windows own scrollbar==NULL
	{
		// user has scrolled one of the 10 scrollbars

		int p=pScrollBar->GetScrollPos();
		int minp,maxp,newp;
		pScrollBar->GetScrollRange(&minp,&maxp);
		switch(nSBCode)
		{
		case SB_LEFT:			newp=minp; 	break;// Scroll to far left.
		case SB_ENDSCROLL:		newp=p;	break;// End scroll.
		case SB_LINELEFT:		newp=max(minp,p-1);	break;// Scroll left.
		case SB_LINERIGHT:		newp=min(maxp,p+1);	break;// Scroll right.
		case SB_PAGELEFT:		newp=max(minp,p-10);break;// Scroll one page left.
		case SB_PAGERIGHT:		newp=min(maxp,p+10);break;// Scroll one page right.
		case SB_RIGHT:			newp=maxp;	break;// Scroll to far right.
		case SB_THUMBPOSITION:	;//newp=nPos;	break;// Scroll to absolute position. The current position is specified by the nPos parameter.
		case SB_THUMBTRACK:		newp=nPos;	break;// Drag scroll box to specified position. The current position is specified by the nPos parameter.
		default:AfxMessageBox("What is this?");
		}
		
		// update correct scrollbar and edit variables
		if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_A_RED))
		{	m_a_red=(float)newp/100.0f; m_scr_a_red=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_A_GREEN))
		{	m_a_green=(float)newp/100.0f; m_scr_a_green=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_A_BLUE)) 
		{	m_a_blue=(float)newp/100.0f; m_scr_a_blue=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_D_RED)) 
		{	m_d_red=(float)newp/100.0f; m_scr_d_red=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_D_GREEN)) 
		{	m_d_green=(float)newp/100.0f; m_scr_d_green=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_D_BLUE)) 
		{	m_d_blue=(float)newp/100.0f; m_scr_d_blue=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_S_RED)) 
		{	m_s_red=(float)newp/100.0f; m_scr_s_red=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_S_GREEN)) 
		{	m_s_green=(float)newp/100.0f; m_scr_s_green=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_S_BLUE)) 
		{	m_s_blue=(float)newp/100.0f; m_scr_s_blue=newp;	}
		else if(pScrollBar==(CScrollBar*)GetDlgItem(IDC_SCROLL_SHINE)) 
		{	m_shine=(float)newp; m_scr_shine=newp;		}
		else
			AfxMessageBox("What is this?");

		UpdateData(FALSE); // both scrollbars and edits

			
		UpdateImageAndCode();
	}
	else
	
	CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CMatedView::OnChangeEdARed() 
{	UpdateData(); m_scr_a_red=(int)(m_a_red*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdAGreen() 
{	UpdateData(); m_scr_a_green=(int)(m_a_green*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdABlue() 
{	UpdateData(); m_scr_a_blue=(int)(m_a_blue*100);UpdateData(FALSE);UpdateImageAndCode();}


void CMatedView::OnChangeEdDRed() 
{	UpdateData(); m_scr_d_red=(int)(m_d_red*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdDGreen() 
{	UpdateData(); m_scr_d_green=(int)(m_d_green*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdDBlue() 
{	UpdateData(); m_scr_d_blue=(int)(m_d_blue*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdSRed() 
{	UpdateData(); m_scr_s_red=(int)(m_s_red*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdSGreen() 
{	UpdateData(); m_scr_s_green=(int)(m_s_green*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdSBlue() 
{	UpdateData(); m_scr_s_blue=(int)(m_s_blue*100);UpdateData(FALSE);UpdateImageAndCode();}

void CMatedView::OnChangeEdShine() 
{	UpdateData(); m_scr_shine=(int)m_shine;UpdateData(FALSE);UpdateImageAndCode();}



void CMatedView::OnMenuSelStd() 
{
	// show std materials for choice
	if(m_Mat.DoModal()==IDOK)
	{
		int ix=m_Mat.Get_Current_Index();
		LoadMaterial(ix);

		UpdateData(FALSE);
		UpdateImageAndCode();

	};
	
}

void CMatedView::LoadMaterial(int ix)
{
		m_Mat.GetAmbientMat(ix,m_a_red,m_a_green,m_a_blue);
		m_Mat.GetDiffuseMat(ix,m_d_red,m_d_green,m_d_blue);
		m_Mat.GetSpecularMat(ix,m_s_red,m_s_green,m_s_blue);
		m_Mat.GetShinyMat(ix,m_shine);
		m_shine=m_shine*128.0f;

		// and scrolls
		///////////////////////////////////////////////////////
		m_scr_a_red=(int)(m_a_red*100);
		m_scr_a_green=(int)(m_a_green*100);
		m_scr_a_blue=(int)(m_a_blue*100);
		m_scr_d_red=(int)(m_d_red*100);
		m_scr_d_green=(int)(m_d_green*100);
		m_scr_d_blue=(int)(m_d_blue*100);
		m_scr_s_red=(int)(m_s_red*100);
		m_scr_s_green=(int)(m_s_green*100);
		m_scr_s_blue=(int)(m_s_blue*100);
		m_scr_shine=(int)m_shine;
		////////////////////////////////////////////////////

}

void CMatedView::ProduceCode()
{
	// fills up code in editbox
	CString sa,sd,ss,ssh,all;
	CString s1,s2,s3;
	((CWnd*)(GetDlgItem(IDC_ED_A_RED)))->GetWindowText(s1);
	((CWnd*)(GetDlgItem(IDC_ED_A_GREEN)))->GetWindowText(s2);
	((CWnd*)(GetDlgItem(IDC_ED_A_BLUE)))->GetWindowText(s3);
	if(s1=="0") s1="0.0"; else if (s1=="1") s1="1.0";
	if(s2=="0") s2="0.0"; else if (s2=="1") s2="1.0";
	if(s3=="0") s3="0.0"; else if (s3=="1") s3="1.0";
	
	wsprintf(sa.GetBuffer(100),"GLfloat "+str_amb+"[]={%sf,%sf,%sf,1.0f};\r\n",s1,s2,s3);
	sa.ReleaseBuffer();
	
	((CWnd*)(GetDlgItem(IDC_ED_D_RED)))->GetWindowText(s1);
	((CWnd*)(GetDlgItem(IDC_ED_D_GREEN)))->GetWindowText(s2);
	((CWnd*)(GetDlgItem(IDC_ED_D_BLUE)))->GetWindowText(s3);
	if(s1=="0") s1="0.0"; else if (s1=="1") s1="1.0";
	if(s2=="0") s2="0.0"; else if (s2=="1") s2="1.0";
	if(s3=="0") s3="0.0"; else if (s3=="1") s3="1.0";
	
	wsprintf(sd.GetBuffer(100),"GLfloat "+str_dif+"[]={%sf,%sf,%sf,1.0f};\r\n",s1,s2,s3);
	sd.ReleaseBuffer();
	
	((CWnd*)(GetDlgItem(IDC_ED_S_RED)))->GetWindowText(s1);
	((CWnd*)(GetDlgItem(IDC_ED_S_GREEN)))->GetWindowText(s2);
	((CWnd*)(GetDlgItem(IDC_ED_S_BLUE)))->GetWindowText(s3);
	if(s1=="0") s1="0.0"; else if (s1=="1") s1="1.0";
	if(s2=="0") s2="0.0"; else if (s2=="1") s2="1.0";
	if(s3=="0") s3="0.0"; else if (s3=="1") s3="1.0";
	
	wsprintf(ss.GetBuffer(100),"GLfloat "+str_spec+"[]={%sf,%sf,%sf,1.0f};\r\n",s1,s2,s3);
	ss.ReleaseBuffer();
	
	((CWnd*)(GetDlgItem(IDC_ED_SHINE)))->GetWindowText(s1);
	wsprintf(ssh.GetBuffer(100),"GLfloat "+str_shine+"=%sf;\r\n",s1);
	ssh.ReleaseBuffer();


	CString ca="glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,"+str_amb+");\r\n";
	CString cd="glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,"+str_dif+");\r\n";
	CString cs="glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,"+str_spec+");\r\n";
	CString csh="glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,"+str_shine+");";

	all="/* comment the material*/\r\n";
	all+=sa;
	all+=sd;
	all+=ss;
	all+=ssh;
	all+=ca;
	all+=cd;
	all+=cs;
	all+=csh;

	((CWnd*)(GetDlgItem(IDC_EDIT_CODE)))->SetWindowText(all);

}

void CMatedView::UpdateImageAndCode()
{
	m_pW->RedrawWindow();
	ProduceCode();
}

